// $Id: FXMLTest.java,v 1.2 2007-08-24 12:39:51 pierre Exp $

package com.senellart.pierre.fuzzyxml;

import com.senellart.pierre.fuzzyxml.document.DocumentManager;
import com.senellart.pierre.fuzzyxml.document.FileDocumentManager;
import com.senellart.pierre.fuzzyxml.exception.FuzzyXMLConfigurationException;
import com.senellart.pierre.fuzzyxml.update.Update;
import com.senellart.pierre.fuzzyxml.update.XSLTUpdate;

/**
 * @author pierre
 * 
 */
public class FXMLTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		if (args.length != 2) {
			System.err.println("Incorrect number of arguments.");
			System.exit(1);
		}

		FuzzyXMLEnvironment environ = null;
		try {
			environ = new FuzzyXMLEnvironment("/home/pierre/fuzzyxml");
		} catch (FuzzyXMLConfigurationException e1) {
			e1.printStackTrace();
			System.exit(1);
		}

		DocumentManager dm = null;

		try {
			dm = new FileDocumentManager(environ);
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}

		Update upd = null;

		try {
			// q=qf.newQuery("/*//title");//System.exit(0);
			upd=dm.getUpdateFactory().newUpdate("/pubs/pub[author[.=\"Senelard\"]]","",new String[0],0.8);
		}/*
			 * catch (FileNotFoundException e) { System.err.println("No such
			 * file: '" + args[0] + "'."); System.exit(1); }
			 */catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}

		try {
			environ.serialize(((XSLTUpdate)upd).executeAndReturn(dm.getDocument(args[1])),System.err);
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}

		//File dotFile = null;
		try {
			//dotFile = File.createTempFile("fxml", ".dot");
			// environ.serialize(result,System.out);System.exit(0);
			//Document doc = environ.getDOMParser().parse(args[1]);
			//environ.fuzzyxml2dot(doc, new FileOutputStream(dotFile));
		} catch (Exception e) {
			//e.printStackTrace();
			//System.exit(1);
		}

		/*try {
			//System.out.println(new GraphViz(dotFile).generate("svg", null));
		} catch (IOException e) {
			//e.printStackTrace();
			//System.exit(1);
		}*/
	}
}
