// $Id: ExecuteUpdateServlet.java,v 1.2 2007-08-24 12:39:51 pierre Exp $

package com.senellart.pierre.fuzzyxml.demo;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.w3c.dom.Document;

import com.senellart.pierre.fuzzyxml.update.Update;
import com.senellart.pierre.fuzzyxml.update.XSLTUpdate;

public class ExecuteUpdateServlet extends FuzzyXMLServlet {
	static final long serialVersionUID = -4750119811722664038L;

	protected void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		super.doGet(req, res);

		try {
			Update update = documentManager.getUpdateFactory().newUpdate(
					req.getParameter("query"),
					req.getParameter("join"),
					req.getParameterValues("insertion"),
					Double.parseDouble((req.getParameter("confidence"))));

			Document result = ((XSLTUpdate) update)
					.executeAndReturn(documentManager.getDocument("pubs.xml"));

			File dotFile = createDotFile();

			environment.fuzzyxml2dot(result, new FileOutputStream(dotFile));

			returnImage(res, dotFile);
		} catch (Exception e) {
			throw new ServletException(e);
		}
	}
}
