// $Id: DocumentManager.java,v 1.1.1.1 2006-03-22 13:32:17 pierre Exp $

package com.senellart.pierre.fuzzyxml.document;

import java.util.HashMap;
import java.util.Map;

import com.senellart.pierre.fuzzyxml.FuzzyXMLEnvironment;
import com.senellart.pierre.fuzzyxml.query.QueryFactory;
import com.senellart.pierre.fuzzyxml.update.UpdateFactory;

public abstract class DocumentManager {
	protected FuzzyXMLEnvironment environment;
	protected QueryFactory queryFactory;
	protected UpdateFactory updateFactory;
	private Map documentMap;

	public FXMLDocument getDocument(String documentId) {
		if(documentMap.containsKey(documentId))
			return (FXMLDocument)documentMap.get(documentId);
		else
			return registerDocument(documentId);
	}
	
	abstract protected FXMLDocument registerDocument(String documentId);

	protected DocumentManager(FuzzyXMLEnvironment environment) {
		this.environment=environment;
		documentMap=new HashMap();
	}

	public FuzzyXMLEnvironment getEnvironment() {
		return environment;
	}

	public QueryFactory getQueryFactory() {
		return queryFactory;
	}
	
	public UpdateFactory getUpdateFactory() {
		return updateFactory;
	}
}
