// $Id: EventConjunction.java,v 1.1.1.1 2006-03-22 13:32:17 pierre Exp $

package com.senellart.pierre.fuzzyxml.event;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

public class EventConjunction extends EventFormula {
	private Map events;
	
	public EventConjunction() {
		events=new HashMap();
	}
	
	public void add(String id,boolean pos)
	{
		events.put(id,new Boolean(pos));
	}
	
	public boolean contains(String id)
	{
		return events.containsKey(id);
	}
	
	public boolean get(String id)
	{
		return ((Boolean)events.get(id)).booleanValue();
	}
	
	public boolean isTautology()
	{
		return events.isEmpty();
	}

	public Set getIds() {
		return events.keySet();
	}

	public EventConjunction except(EventConjunction otherEvents) {
		EventConjunction newEvents = new EventConjunction();

		Set eventSet = getIds();
		for (Iterator eventIt = eventSet.iterator(); eventIt
				.hasNext();) {
			String e = (String)eventIt.next();
			if (!otherEvents.contains(e))
				newEvents.add(e, get(e));
		}
		
		return newEvents;
	}

	protected boolean evaluate(Assignment a) {
		for(Iterator it=getIds().iterator();it.hasNext();) {
			String id=(String)it.next();
			
			if(a.get(id)!=get(id))
				return false;
		}
		
		return true;
	}
}
