// $Id: EventDisjunctiveFormula.java,v 1.1.1.1 2006-03-22 13:32:17 pierre Exp $

package com.senellart.pierre.fuzzyxml.event;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

public class EventDisjunctiveFormula extends EventFormula {
	Set disjunction;

	public EventDisjunctiveFormula() {
		disjunction=new HashSet();
	}
	
	public void addTerm(EventFormula F) {
		disjunction.add(F);
	}

	public Set getIds() {
		Set result=new HashSet();
		
		for(Iterator it=disjunction.iterator();it.hasNext();) {
			Set ids=((EventFormula)it.next()).getIds();
			for(Iterator jt=ids.iterator();jt.hasNext();)
				result.add(jt.next());
			
		}
		
		return result;
	}

	protected boolean evaluate(Assignment a) {
		for(Iterator it=disjunction.iterator();it.hasNext();) {
			EventFormula f=(EventFormula)it.next();
			
			if(f.evaluate(a))
				return true;
		}
		
		return false;
	}

	public Set getTerms() {
		return disjunction;
	}
}
