/* Generated By: PathExpr.jj,v 1.1.1.1 2006-03-22 13&JavaCC: Do not edit this line. PathExpr.java */
package com.senellart.pierre.fuzzyxml.pathexpr;

import org.w3c.dom.*;
import java.io.*;
import java.util.*;
import com.senellart.pierre.fuzzyxml.exception.*;
import com.senellart.pierre.fuzzyxml.FuzzyXML;

public class PathExpr implements PathExprConstants {
  protected Map refMap;
  protected int current_id;
  protected Document document;

  protected void initialize(DOMImplementation domImpl,Map map) {
    refMap=map;
    current_id=0;

    document = domImpl.createDocument(FuzzyXML.NAMESPACE_URI,
          "query",
          null);

    Element root=document.getDocumentElement();
  }

  static public Document parse(DOMImplementation domImpl,
        String inString, Map refMap)
        throws InvalidPathExprException {
    Reader reader=new StringReader(inString);
    PathExpr parser=new PathExpr(reader);
    parser.initialize(domImpl,refMap);

    Element root = parser.document.getDocumentElement();

    try {
      parser.Start(root);
    } catch (TokenMgrError e) {
      throw new InvalidPathExprException(e);
    } catch (ParseException e) {
      throw new InvalidPathExprException(e);
    }
    return parser.document;
  }

  final public void Start(Element parent) throws ParseException, InvalidPathExprException {
    jj_consume_token(CHILD);
    Expression(parent,false);
    jj_consume_token(0);
  }

  final public void Expression(Element parent, boolean descendant) throws ParseException, InvalidPathExprException {
  Token t;
  Element element=parent.getOwnerDocument().
    createElementNS(FuzzyXML.NAMESPACE_URI,"element");
  parent.appendChild(element);
  if(descendant)
    element.setAttribute("descendant","1");
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DROP:
      jj_consume_token(DROP);
      element.setAttribute("drop","1");
      break;
    default:
      jj_la1[0] = jj_gen;
      ;
    }
    t = jj_consume_token(NAME);
    element.setAttribute("name",t.image);
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case REF:
      case DELETE:
      case INSERT:
        ;
        break;
      default:
        jj_la1[1] = jj_gen;
        break label_1;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case REF:
        t = jj_consume_token(REF);
       try {
          Integer ref=Integer.valueOf(t.image.substring(1));
          if(refMap.containsKey(ref))
            {if (true) throw new InvalidPathExprException("Multiple use of the same reference");}
          refMap.put(ref,new Integer(current_id));
       } catch(NumberFormatException e) {
         // Should not happen
         {if (true) throw new FuzzyXMLUnsupportedException(e);}
       }
        break;
      case DELETE:
        t = jj_consume_token(DELETE);
       element.appendChild(
         document.createElementNS(FuzzyXML.NAMESPACE_URI,"delete"));
        break;
      case INSERT:
        t = jj_consume_token(INSERT);
       element.appendChild(
         document.createElementNS(FuzzyXML.NAMESPACE_URI,"insert"));
        break;
      default:
        jj_la1[2] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    element.setAttribute("id","n"+current_id++);
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BRANCHSTART:
        ;
        break;
      default:
        jj_la1[3] = jj_gen;
        break label_2;
      }
      if (jj_2_1(3)) {
        Value(element);
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case BRANCHSTART:
          Branch(element);
          break;
        default:
          jj_la1[4] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case DESCENDANT:
    case CHILD:
      FinalBranch(element);
      break;
    default:
      jj_la1[5] = jj_gen;
      ;
    }
  }

  final public void Value(Element parent) throws ParseException {
  Token t;
    jj_consume_token(BRANCHSTART);
    jj_consume_token(CURRENT);
    jj_consume_token(EQUAL);
    t = jj_consume_token(STRING_LITERAL);
    jj_consume_token(BRANCHEND);
    Element value=
      document.createElementNS(FuzzyXML.NAMESPACE_URI,"value");
    value.appendChild(document.createTextNode(t.image.substring(1,t.image.length()-1)));
    parent.appendChild(value);
  }

  final public void Branch(Element parent) throws ParseException, InvalidPathExprException {
  boolean descendant=false;
    jj_consume_token(BRANCHSTART);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CURRENT:
      jj_consume_token(CURRENT);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case CHILD:
        jj_consume_token(CHILD);
        break;
      case DESCENDANT:
        jj_consume_token(DESCENDANT);
        descendant=true;
        break;
      default:
        jj_la1[6] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      Expression(parent, descendant);
      break;
    case DROP:
    case NAME:
      Expression(parent, false);
      break;
    default:
      jj_la1[7] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(BRANCHEND);
  }

  final public void FinalBranch(Element parent) throws ParseException, InvalidPathExprException {
  boolean descendant=false;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CHILD:
      jj_consume_token(CHILD);
      break;
    case DESCENDANT:
      jj_consume_token(DESCENDANT);
      descendant=true;
      break;
    default:
      jj_la1[8] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    Expression(parent, descendant);
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  final private boolean jj_3R_3() {
    if (jj_scan_token(BRANCHSTART)) return true;
    if (jj_scan_token(CURRENT)) return true;
    if (jj_scan_token(EQUAL)) return true;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_3R_3()) return true;
    return false;
  }

  public PathExprTokenManager token_source;
  SimpleCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[9];
  static private int[] jj_la1_0;
  static {
      jj_la1_0();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x400,0x70000,0x70000,0x80,0x80,0x60,0x60,0x8600,0x60,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[1];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public PathExpr(java.io.InputStream stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new PathExprTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 9; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 9; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public PathExpr(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new PathExprTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 9; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 9; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public PathExpr(PathExprTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 9; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(PathExprTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 9; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration e = jj_expentries.elements(); e.hasMoreElements();) {
        int[] oldentry = (int[])(e.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[20];
    for (int i = 0; i < 20; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 9; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 20; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 1; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
