// $Id: GraphViz.java,v 1.1.1.1 2006-03-22 13:32:17 pierre Exp $

package com.senellart.pierre.util;

import java.io.File;
import java.io.IOException;

/**
 * @author pierre
 * 
 */
public class GraphViz {
	private File dotFile;

	public GraphViz(File dotFile) {
		this.dotFile = dotFile;
	}

	public File generate(String type, File directory) throws IOException {
		File imgFile;

		imgFile = File.createTempFile("fxml", "." + type, directory);

		String dotCommand[] = { "dot", "-T" + type, "-o",
				imgFile.getAbsolutePath(), dotFile.getAbsolutePath() };

		Runtime runtime = Runtime.getRuntime();

		Process p = runtime.exec(dotCommand);
		
		try {
			p.waitFor();
		} catch (InterruptedException e) {
			// Do nothing
		}

		return imgFile;
	}

	protected void finalize() {
		dotFile.delete();
	}
}
